#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "register_after_fork4xi.py">
#<abstract4xi abstract = "providing function register_after_fork4xi"/>
#<refer4xi reference = "util.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'register_after_fork4xi' ] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import itertools
    import weakref         
except:
    pass
try:                 # rare ones
    import atexit
    import logging         
except:
    pass 
try:                 # imported-as ones 
    pass          
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    pass
except:
    pass
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import after_fork4xi
from after_fork4xi import _afterfork_counter
from after_fork4xi import _afterfork_registry

from print4xi import print4xi
from time4xi import time4xi
#"
#/> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "register_after_fork4xi" usage = "
#   util.py
#       class ForkAwareThreadLock(object):
#           def __init__(self):
#               register_after_fork(self, ForkAwareThreadLock.__init__) # object=self                             
#
#   forkawarethreadlock4xi.py
#       register_after_fork4xi(self, ForkAwareThreadLock4Xi.__init__)
#   baseproxy4xi.py:
#       register_after_fork4xi(self, BaseProxy4Xi._after_fork)
#
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def register_after_fork4xi(obj, func):
    '''
    updates _afterfork_registry
    '''
    
    # ---------------------------------------------------------------------------------------------
    #
    # ---------------------------------------------------------------------------------------------    
    class2print = "register_after_fork4xi"
    method2print = "register_after_fork4xi"
    
    message2print = "{started" + "; register-after-fork4xi-started: " + str(register_after_fork4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        
    message2print = "{passed" + "; object-passed-to-register-after-fork4xi: " + str(obj) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                  
    message2print = "{passed" + "; function-passed-to-register-after-fork4xi: " + str(func) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                    

    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------     
    ack2upgrade = False
    nack2upgrade = True
    try:
        _afterfork_registry[(next(_afterfork_counter), id(obj), func)] = obj

        message2print = "{upgraded" + "; afterfork-registry-upgraded-by-register-after-fork4xi: " + str(_afterfork_registry)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 

        ack2upgrade = True
        
        message2print = "{set" + "; ack2upgrade-set-by-register-after-fork4xi to: " + str(ack2upgrade)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        
        
        
    except:
        message2print = "{yielded" + "; nack2upgrade-yielded-by-register-after-fork4xi: " + str(nack2upgrade)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
            
    # -------------------------------------------------------------------------------------------
    #
    # --------------------------------------------------------------------------------------------- 
    message2print = "{returning" + "; register-after-fork4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
          
#</function4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of register_after_fork4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

